/*******************************************************************************
 *                                                                             *
 *                                                                             *
 *                                                                             *
 *                                                                             *
 *                                                                             *
 *                                                                             *
 * 


 *******************************************************************************/


#include <cm/cmmd.h>
#include <stdio.h>
#include <stdlib.h>

#include "global.h"

#define  Max 128  /* maximum number of array size */


/*******************************************************************************
 *                                                                             *
 *   Global variables                                                          *
 *                                                                             *
 *******************************************************************************/
int    input[Max], /* input array */
       mask[Max];  /* mask array */


/*******************************************************************************
 *   Procedure :                                                               *
 *   Input     :                                                               *
 *   Output    :                                                               *
 *   Function  :                                                               *
 *******************************************************************************/
/*******************************************************************************
 *   Procedure :                                                               *
 *   Input     :                                                               *
 *   Output    :                                                               *
 *   Function  :                                                               *
 *******************************************************************************/
/*******************************************************************************
 *   Procedure :                                                               *
 *   Input     :                                                               *
 *   Output    :                                                               *
 *   Function  :                                                               *
 *******************************************************************************/

/*******************************************************************************
 *   Procedure : initialize()                                                  *
 *   Input     :                                                               *
 *   Output    :                                                               *
 *   Function  :                                                               *
 *******************************************************************************/
void initialize()
{
  int i;


}

/*******************************************************************************
 *                                                                             * 
 *                              MAIN  PROGRAM                                  *
 *                                                                             *
 *******************************************************************************
 *                                                                             *
 *                                                                             *
 *   -  argv[1] = Mask Array file                                              *
 *   -  argv[2] = Input Array file                                             *
 *                                                                             *
 *******************************************************************************/
  
main(argc, argv)
     int argc;
     char *argv[];
{
  FILE   *fd1, /* for mask array file */
         *fd2; /* for input array file */

  int    i, j, k;


  /*-------------------------  Initialize  -----------------------------*/

  CMMD_disable_safety();
  CMMD_fset_io_mode(stdin, CMMD_sync_bc);
  CMMD_fset_io_mode(stdout, CMMD_sync_bc);
  CMMD_fset_io_mode(stderr, CMMD_independent);

  if (argc < 6) {
    printf("Usage: (1) mask file name \n");
    printf("Usage: (2) input file name \n");
    printf("Usage: (3) # of processors in a row \n");
    printf("Usage: (4) # of processors in a column \n");
    printf("Usage: (5) tile size in a row \n");
    printf("Usage: (6) tile size in a column \n");
    exit(1);
  }

  buf_size = Nlocal * Nlocal * sizeof(double);

/*  ori_nproc = CMMD_partition_size(); */

  my_id = CMMD_self_address(); 

  proc_row = atoi(argv[3]);
  proc_column = atoi(argv[4]);

  nproc = proc_row * proc_column;

  tile_row = atoi(argv[5]);
  tile_column = atoi(argv[6]);

  i = CMMD_reset_partition_size(nproc);

  if (i != nproc) 
    CMMD_error("\nERROR: CMMD Partition failed!\n");

  /* 0 processor reads the mask & input array from the file */
  if ( my_id == 0 ) {
    /* get input data from file */
    fd1 = fopen(argv[1], "r");
    fd2 = fopen(argv[2], "r");

    if ( fd1 == NULL ) {
      printf("\ncannot find file %s!\n", argv[1]);
      exit(1);
    }

    if ( fd2 == NULL ) {
      printf("\ncannot find file %s!\n", argv[2]);
      exit(1);
    }

    /* read the size of the matrix. */
    for ( i = 0 ; i < Max ; i++ ) {
      fscanf(fd1, "%d", &mask[i]);
      fscanf(fd2, "%d", &input[i]);
    }
  }
  fclose(fd1);
  fclose(fd2);

  CMMD_sync_with_nodes();

  /* distribute the data */

  if ( pnum == 0 ) {
    for ( i = 1 ; i < nproc ; i++ ) {
      CMMD_receive_block( i, CMMD_DEFAULT_TAG, buf, sizeof(int));

      CMMD_fset_io_mode(stdout, CMMD_independent);
      printf("From %d \n", buf[0]);
/*      CMMD_sync_with_nodes();*/

    }
  }
  else {
    CMMD_free_mcb(
     CMMD_send_async( 0, CMMD_DEFAULT_TAG, buf, sizeof(int), NULL, NULL));

/*    CMMD_send_async( 0,   CMMD_DEFAULT_TAG, buf, sizeof(int));*/
  }

  /*---------------------  Print out the timiing result   ---------------------*/
  CMMD_fset_io_mode(stdout, CMMD_sync_bc);
  printf("\n\n");
  printf("***********************************************\n");
  printf("                 Input Data  \n");
  printf("***********************************************\n");
  printf("   Number of processors = %4d\n", nproc);

}

